commit 32afc4af2cd25dafb6df4d2d53e2594229f49c6e
Author: freddy77 <freddy77>
Date:   Tue Feb 12 15:41:51 2008 +0000

    fix possible memory errors

diff --git b/ChangeLog a/ChangeLog
index 3349c0f..34b8f87 100644
--- b/ChangeLog
+++ a/ChangeLog
@@ -1,7 +1,3 @@
-Tue Feb 12 16:41:02 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
-	* src/apps/bsqlodbc.c: fix memory error
-	* src/tds/query.c: remove possible buffer underflow
-
 Wed Feb 06 09:48:32 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/tds/unittests/t0007.c: test more data
 
@@ -81,4 +77,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2454.2.17 2008/02/12 15:41:51 freddy77 Exp $
+$Id: ChangeLog,v 1.2454.2.16 2008/02/06 08:49:44 freddy77 Exp $
diff --git b/src/apps/bsqlodbc.c a/src/apps/bsqlodbc.c
index 5a6cc42..1050550 100644
--- b/src/apps/bsqlodbc.c
+++ a/src/apps/bsqlodbc.c
@@ -50,7 +50,7 @@
 #include <sqlext.h>
 #include "replacements.h"
 
-static char software_version[] = "$Id: bsqlodbc.c,v 1.9.2.1 2008/02/12 15:41:51 freddy77 Exp $";
+static char software_version[] = "$Id: bsqlodbc.c,v 1.9 2007/11/26 06:25:57 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static char * next_query(void);
@@ -354,8 +354,7 @@ next_query()
 	fprintf(options.verbose, "%s:%d: Query:\n", options.appname, __LINE__);
 	
 	free(sql);
-	sql = NULL;
-
+	
 	while (fgets(query_line, sizeof(query_line), stdin)) {
 		/* 'go' or 'GO' separates command batches */
 		char *p = query_line;
diff --git b/src/tds/query.c a/src/tds/query.c
index 3996aef..8ef57f7 100644
--- b/src/tds/query.c
+++ a/src/tds/query.c
@@ -46,7 +46,7 @@
 
 #include <assert.h>
 
-TDS_RCSID(var, "$Id: query.c,v 1.217.2.1 2008/02/12 15:41:51 freddy77 Exp $");
+TDS_RCSID(var, "$Id: query.c,v 1.217 2008/01/05 11:24:40 freddy77 Exp $");
 
 static void tds_put_params(TDSSOCKET * tds, TDSPARAMINFO * info, int flags);
 static void tds7_put_query_params(TDSSOCKET * tds, const char *query, int query_len);
@@ -577,7 +577,7 @@ tds_next_placeholder_ucs2le(const char *start, const char *end, int named)
 		case '?':
 			return p;
 		case '@':
-			if (named && !isalnum((unsigned char) prev))
+			if (named && !isalnum(prev))
 				return p;
 		default:
 			p += 2;
@@ -849,7 +849,7 @@ tds7_build_param_def_from_params(TDSSOCKET * tds, const char* query, size_t quer
 					continue;
 				/* find end of param name */
 				for (id_end = e + 2; id_end != query_end; id_end += 2)
-					if (!id_end[1] && (id_end[0] != '_' && id_end[1] != '#' && !isalnum((unsigned char) id_end[0])))
+					if (!id_end[1] && (id_end[0] != '_' && id_end[1] != '#' && !isalnum(id_end[0])))
 						break;
 				ids[i].p = e;
 				ids[i].len = id_end - e;

